"""Simple WSGI applications

Run them like so::

    ajp-wsgi test app
    ajp-wsgi test test_app

"""

def app(environ, start_response):
    start_response('200 OK', [('Content-Type', 'text/plain')])
    return ['Hello World!\n']

def test_app(environ, start_response):
    import cgi
    start_response('200 OK', [('Content-Type', 'text/html')])
    yield '<html><head><title>Hello World!</title></head>\n' \
          '<body>\n' \
          '<p>Hello World!</p>\n' \
          '<table border="1">'
    names = environ.keys()
    names.sort()
    for name in names:
        yield '<tr><td>%s</td><td>%s</td></tr>\n' % (
            name, cgi.escape(`environ[name]`))

    form = cgi.FieldStorage(fp=environ['wsgi.input'], environ=environ,
                            keep_blank_values=1)
    if form.list:
        yield '<tr><th colspan="2">Form data</th></tr>'

    for field in form.list:
        yield '<tr><td>%s</td><td>%s</td></tr>\n' % (
            field.name, field.value)

    yield '</table>\n' \
          '</body></html>\n'

# Wrap with wsgiref's validator, if available
try:
    from wsgiref.validate import validator
except ImportError:
    pass
else:
    app = validator(app)
    test_app = validator(test_app)
